%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                             %
% Wie können Sie fragen, ob die Strings aaabbbcccundaabbbcc   %
% von den Grammatiken generiert werden?                       %
%                                                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

s1 --> ablock1(Count),bblock1(Count),cblock1(Count).            % Die Anfrage ist erfolgreich, wenn ablock1, bblock1 und cblock1 gelesen werden können
ablock1(0) --> [].                                              % wird kein a gelesen, entsteht die leere Liste
ablock1(succ(Count)) --> [a],ablock1(Count).                    % wird ein a gelesen, wird succ(Count) um eins erhört und das gelesene a vom Stack gelöscht
bblock1(0) --> [].                                              % wird kein b gelesen, entsteht die leere Liste
bblock1(succ(Count)) --> [b],bblock1(Count).                    % wird ein b gelesen, wird succ(Count) um eins erhört und das gelesene b vom Stack gelöscht
cblock1(0) --> [].                                              % wird kein c gelesen, entsteht die leere Liste
cblock1(succ(Count)) --> [c],cblock1(Count).                    % wird ein c gelesen, wird succ(Count) um eins erhört und das gelesene c vom Stack gelöscht            

% Anfrage fuer aaabbbccc
% ?- s1([a, a, a, b, b, b, c, c, c],[]).
% Anfrage fuer aabbbcc
% ?- s1([a, a, b, b, b, c, c],[]).
% Strings generieren
% s1(X,[]).

s2 --> ablock2(Count),bblock2(Count),cblock2(Count).                            % Die Anfrage ist erfolgreich, wenn ablock1, bblock1 und cblock1 gelesen werden können
ablock2(0) --> [].                                                              % wird kein a gelesen, entsteht die leere Liste
ablock2(NewCount) --> [a],ablock2(Count), {NewCount is Count + 1}.              % wird ein a gelesen, so wird der Count mit 1 addiert und als NewCount gespeichert,
                                                                                % solange bis kein a mehr gelesen wird
bblock2(0) --> [].                                                              % wird kein b gelesen, entsteht die leere Liste
bblock2(NewCount) --> [b],bblock2(Count), {NewCount is Count + 1}.              % wird ein b gelesen, so wird der Count mit 1 addiert und als NewCount gespeichert
                                                                                % solange bis kein b mehr gelesen wird
cblock2(0) --> [].                                                              % wird kein c gelesen, entsteht die leere Liste
cblock2(NewCount) --> [c],cblock2(Count), {NewCount is Count + 1}.              % wird ein a gelesen, so wird der Count mit 1 addiert und als NewCount gespeichert
                                                                                % solange bis kein c mehr gelesen wird 


% Anfrage fuer aaabbbccc
% ?- s2([a, a, a, b, b, b, c, c, c],[]).
% Anfrage fuer aabbbcc
% ?- s2([a, a, b, b, b, c, c],[]).
% Strings generieren
% nicht moeglich
