%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                       %
% Schreibe die Grammatik als parametrisierte DCG        %
%                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% Grammatikregeln 
% Die Grammatikregeln geben Informationen über den notwendigen Kasus, Numerus und Genus.
s(s(NP, VP)) --> np(NP,(nom,Num,_)), vp(VP,Num).                % generiert einen Satz bestehend aus einer NP und einer VP
np(np(Det, N),KNG) --> det(Det, KNG), n(N, KNG).                % generiert eine NP bestehend aus einem Determinierer und einem Nomen                        
vp(vp(V, NP),Num) --> v(V, Num), np(NP, (akk,_,_)).             % generiert eine VP bestehend aus einem Verb und einer NP

% Lexikon:
det(det(der),(nom,sing,mas)) --> [der].                         % der ist ein Determinierer im Nominativ, Singular und maskulin      
det(det(den),(akk,sing,mas)) --> [den].                         % den ist ein Determinierer im Akkusativ, Singular und maskulin
det(det(die),(_,sing,fem)) --> [die].                           % die ist ein Determinierer im Singular und feminin, unabhängig von Kasus
det(det(das),(_,sing,neu)) --> [das].                           % das ist ein Determinierer im Singular und neutrum, unabhängig von Kasus
det(det(die),(_,plur,_)) --> [die].                             % die ist ein Determinierer im Plural, unabhängig von Kasus und Genus
det(det([]),(_,plur,_)) --> [].                                 % das leere Element kann als Determinierer im Plural verwendet werden
n(n(maus),(_,sing,fem)) --> [maus].                             % maus ist ein Nomen im Singular und feminin, unabhängig von Kasus
n(n(maeuse),(_,plur,_)) --> [maeuse].                           % maeuse ist ein Nomen im Plural, unabhängig von Kasus und Genus
n(n(katze),(_,sing,fem)) --> [katze].                           % katze ist ein Nomen im Singular und feminin, unabhängig von Kasus
n(n(katzen),(_,plur,_)) --> [katzen].                           % katzen ist ein Nomen im Plural, unabhängig von Kasus und Genus
n(n(hund),(_,sing,mas)) --> [hund].                             % hund ist ein Nomen im Singular und maskulin, unabhängig von Kasus
n(n(hunde),(_,plur,_)) --> [hunde].                           % hunde ist ein Nomen im Plural und maskulin, unabhängig von Kasus
n(n(pferd),(_,sing,neu)) --> [pferd].                           % pferd ist ein Nomen im Singular und neutrum, unabhängig von Kasus
n(n(pferde),(_,plur,_)) --> [pferde].                         % pferde ist ein Nomen im Plural und neutrum, unabhängig von Kasus
v(v(jagt),sing) --> [jagt].                                     % jagt ist ein Verb mit Argument im Singular
v(v(jagen),plur) --> [jagen].                                   % jagen ist ein Verb mit Argument im Plural
